%define qt_maj    4
%define qt_min    3
%define qt_rev    5
%define qt_ver    %{qt_maj}.%{qt_min}
%define qt_vstr   %(echo %{qt_ver} | tr -d '.')
%define qt_pkg    qt%{qt_vstr}


Summary:          The shared library for the Qt GUI toolkit
Name:             %{qt_pkg}
Version:          %{qt_ver}.%{qt_rev}
Release:          1%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Libraries
Source0:          ftp://ftp.trolltech.com/qt/source/qt-x11-opensource-src-%{version}.tar.bz2
Source1:          %{name}.profile
Source10:         %{name}-assistant.desktop
Source11:         %{name}-designer.desktop
Source12:         %{name}-linguist.desktop
Source13:         %{name}-qtconfig.desktop
Patch0:           %{name}-4.3.2-build.patch
URL:              http://trolltech.com/products/qt/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Trolltech ASA
BuildRequires:    cups-devel fontconfig-devel freetype-devel
BuildRequires:    glib2-devel libjpeg-devel libpng-devel
BuildRequires:    libstdc++-devel libtiff-devel openssl-devel
BuildRequires:    mysql-devel >= 4 sqlite-devel unixODBC-devel
BuildRequires:    postgresql-devel zlib-devel mesa-libGLU-devel
BuildRequires:    dbus-devel libmng-devel libxkbfile-devel
BuildRequires:    libSM-devel libX11-devel libXcursor-devel
BuildRequires:    libXext-devel libXfixes-devel libXrender-devel
BuildRequires:    libXinerama-devel libXrandr-devel libXi-devel
BuildRequires:    desktop-file-utils

%description
Qt is a GUI software toolkit which simplifies the task of writing
and maintaining GUI (Graphical User Interface) applications for the
X Window System. It is written in C++ and is fully object-oriented.


%package          config
Summary:          A grapical configuration tool for Qt programs
Group:            User Interface/Desktops
Requires:         %{name} = %{version}-%{release}

%description      config
The %{name}-config package contains a grapical configuration tool for
programs using Qt.


%package          demo
Summary:          Demo programs and examples for the Qt toolkit
Group:            Development/Tools
Requires:         %{name}-devel = %{version}-%{release}

%description      demo
The %{name}-demo package contains qtdemo and program examples for Qt
developers.


%package          devel
Summary:          Development tools for the Qt toolkit
Group:            Development/Libraries
Requires:         %{name} = %{version}-%{release}
Requires:         fontconfig-devel freetype-devel glib2-devel
Requires:         libpng-devel zlib-devel mesa-libGLU-devel
Requires:         dbus-devel libSM-devel libX11-devel
Requires:         libXcursor-devel libXext-devel libXi-devel
Requires:         libXfixes-devel libXrender-devel
Requires:         libXinerama-devel libXrandr-devel

%description      devel
The %{name}-devel package contains the static libraries and header files
for developing software using Qt.


%package          designer
Summary:          A Interface designer (IDE) for the Qt toolkit
Group:            Development/Tools
Requires:         %{name}-devel = %{version}-%{release}

%description      designer
The %{name}-designer package contains an User Interface designer tool for
the Qt toolkit.


%package          mysql
Summary:          The MySQL driver for Qt's SQL classes
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}

%description      mysql
The %{name}-mysql package contains the MySQL driver for Qt's SQL classes
(QSQL).


%package          odbc
Summary:          The ODBC driver for Qt's SQL classes
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}

%description      odbc
The %{name}-odbc package contains the ODBC driver for Qt's SQL classes
(QSQL).


%package          pgsql
Summary:          The PostgreSQL driver for Qt's SQL classes
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}

%description      pgsql
The %{name}-pgsql package contains the PostgreSQL driver for Qt's SQL classes
(QSQL).


%package          sqlite
Summary:          The SQLite driver for Qt's SQL classes
Group:            System Environment/Libraries
Requires:         %{name} = %{version}-%{release}

%description      sqlite
The %{name}-sqlite package contains the SQLite driver for Qt's SQL classes
(QSQL).


%prep
%setup -q -n qt-x11-opensource-src-%{version}
%patch0 -p1


%build
export CFLAGS="${RPM_OPT_FLAGS} -DOPENSSL_NO_KRB5"
export CXXFLAGS="${RPM_OPT_FLAGS} -DOPENSSL_NO_KRB5 -fno-gcse"

BuildLib() {
  %{__mkdir} ${1}
  pushd ${1}

  echo "yes" | \
  ../configure \
	-prefix %{_libdir}/%{qt_pkg}                  \
	-sysconfdir %{_sysconfdir}/%{qt_pkg}/settings \
	-release                                      \
	-largefile                                    \
	-no-exceptions                                \
	-accessibility                                \
	-stl                                          \
	-no-sql-ibase                                 \
	-no-sql-sqlite2                               \
	-plugin-sql-mysql                             \
	-plugin-sql-odbc                              \
	-plugin-sql-psql                              \
	-plugin-sql-sqlite                            \
	-system-sqlite                                \
	-qt3support                                   \
	-system-zlib                                  \
	-qt-gif                                       \
	-system-libtiff                               \
	-system-libpng                                \
	-system-libmng                                \
	-system-libjpeg                               \
	-openssl                                      \
	-cups                                         \
	-iconv                                        \
	-qdbus                                        \
	-no-nas-sound                                 \
	-opengl                                       \
	-sm                                           \
	-xshape                                       \
	-xinerama                                     \
	-xcursor                                      \
	-xrandr                                       \
	-xrender                                      \
	-fontconfig                                   \
	-tablet                                       \
	-xkb                                          \
	-glib                                         \
	${2}

  %{__make} %{?_smp_mflags}

  popd
}

BuildLib "obj-static" "-static -make libs"
BuildLib "obj-shared" "-shared"


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{ld.so.conf.d,profile.d}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{qt_pkg}/settings
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_bindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/{applications,pixmaps}

for BLDDIR in obj-static obj-shared; do
  pushd ${BLDDIR}

  %{__make} \
	INSTALL_ROOT=${RPM_BUILD_ROOT} \
	install

  for OBJ in `ls include`; do
    if [ -f include/${OBJ}/${OBJ} -a -d ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/include/${OBJ} ]; then
      %{__install} -m 0644 include/${OBJ}/${OBJ} ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/include/${OBJ}
    fi
  done

  popd
done

for FILE in assistant designer linguist qtconfig; do
  %{__ln_s}  %{_libdir}/%{qt_pkg}/bin/${FILE}    ${RPM_BUILD_ROOT}%{_bindir}/${FILE}%{qt_vstr}
done

%{__ln_s} -f %{_sysconfdir}/%{qt_pkg}            ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/etc
%{__ln_s} -f %{_docdir}/%{name}-devel-%{version} ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/doc

%{__mv}   -f ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/lib/pkgconfig ${RPM_BUILD_ROOT}%{_libdir}

# GUI support
desktop-file-install --vendor="%{qt_pkg}"  --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE10}
desktop-file-install --vendor="%{qt_pkg}"  --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE11}
desktop-file-install --vendor="%{qt_pkg}"  --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE12}
desktop-file-install --vendor="%{qt_pkg}"  --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE13}

pushd tools/assistant
%{__install} -m 0644 images/assistant.png        ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/assistant%{qt_vstr}.png
%{__install} -m 0644 images/designer.png         ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/designer%{qt_vstr}.png
%{__install} -m 0644 images/linguist.png         ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/linguist%{qt_vstr}.png
%{__install} -m 0644 images/qt.png               ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/qtconfig%{qt_vstr}.png
popd

# Fix paths
REPL1="`echo ${RPM_BUILD_DIR} | %{__sed} -e \"s#^/[^/]*##g\"`/qt-x11-opensource-src-%{version}/obj-shared"
REPL2="-L${RPM_BUILD_DIR}/qt-x11-opensource-src-%{version}/obj-shared/lib "
REPL3="-L`dirname %{_topdir}`/lib "
REPL4="-L/%{_lib} "
for FILE in `ls ${RPM_BUILD_ROOT}%{_libdir}/pkgconfig/*.pc`; do
  %{__sed} -i -e "s#${REPL1}##g" -e "s#${REPL2}##g" -e "s#${REPL3}##g" -e "s#${REPL4}##g" ${FILE}
done

%{__sed} -e "s#XXX_QTDIR_XXX#%{_libdir}/%{qt_pkg}#g" %{SOURCE1} > \
	${RPM_BUILD_ROOT}%{_sysconfdir}/profile.d/%{qt_pkg}.sh
%{__chmod} 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/profile.d/%{qt_pkg}.sh

# ld config
echo "%{_libdir}/%{qt_pkg}/lib"                                 > \
	${RPM_BUILD_ROOT}%{_sysconfdir}/ld.so.conf.d/%{qt_pkg}-%{_arch}.conf
%{__chmod} 0644 ${RPM_BUILD_ROOT}%{_sysconfdir}/ld.so.conf.d/%{qt_pkg}-%{_arch}.conf

# Cleanup
%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/%{qt_pkg}/lib/lib*.so.{?,?.?}


%post -p /sbin/ldconfig


%preun
%{__rm} -f %{_libdir}/%{qt_pkg}/lib/lib*.so.{?,?.?}


%postun -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc GPL* INSTALL LICENSE* OPENSOURCE* README changes-*
%{_sysconfdir}/ld.so.conf.d/%{qt_pkg}-%{_arch}.conf
%dir %{_sysconfdir}/%{qt_pkg}
%config(noreplace) %{_sysconfdir}/%{qt_pkg}/*
%dir %{_libdir}/%{qt_pkg}
%dir %{_libdir}/%{qt_pkg}/bin
%{_libdir}/%{qt_pkg}/etc
%dir %{_libdir}/%{qt_pkg}/lib
%{_libdir}/%{qt_pkg}/lib/libQt*.so.%{qt_ver}.%{qt_rev}
%{_libdir}/%{qt_pkg}/phrasebooks
%dir %{_libdir}/%{qt_pkg}/plugins
%dir %{_libdir}/%{qt_pkg}/plugins/accessible
%{_libdir}/%{qt_pkg}/plugins/accessible/*.so
%dir %{_libdir}/%{qt_pkg}/plugins/codecs
%{_libdir}/%{qt_pkg}/plugins/codecs/*.so
%dir %{_libdir}/%{qt_pkg}/plugins/iconengines
%{_libdir}/%{qt_pkg}/plugins/iconengines/*.so
%dir %{_libdir}/%{qt_pkg}/plugins/imageformats
%{_libdir}/%{qt_pkg}/plugins/imageformats/*.so
%dir %{_libdir}/%{qt_pkg}/plugins/inputmethods
%{_libdir}/%{qt_pkg}/plugins/inputmethods/*.so
%dir %{_libdir}/%{qt_pkg}/plugins/sqldrivers
%dir %{_libdir}/%{qt_pkg}/translations
%{_libdir}/%{qt_pkg}/translations/qt_*.qm
%{_libdir}/%{qt_pkg}/translations/qvfb_*.qm

%files config
%defattr(-,root,root)
%{_bindir}/qtconfig%{qt_vstr}
%{_libdir}/%{qt_pkg}/bin/qtconfig
%{_libdir}/%{qt_pkg}/translations/qtconfig_*.qm
%config(noreplace) %{_datadir}/applications/%{qt_pkg}-qtconfig.desktop
%{_datadir}/pixmaps/qtconfig%{qt_vstr}.png

%files demo
%defattr(-,root,root)
%{_libdir}/%{qt_pkg}/bin/qtdemo
%{_libdir}/%{qt_pkg}/demos
%{_libdir}/%{qt_pkg}/examples

%files devel
%defattr(-,root,root)
%doc %dir doc/html
%config(noreplace) %{_sysconfdir}/profile.d/%{qt_pkg}.sh
%{_bindir}/assistant%{qt_vstr}
%{_libdir}/%{qt_pkg}/bin/assistant
%{_libdir}/%{qt_pkg}/bin/moc
%{_libdir}/%{qt_pkg}/bin/qdbus
%{_libdir}/%{qt_pkg}/bin/qdbuscpp2xml
%{_libdir}/%{qt_pkg}/bin/qdbusviewer
%{_libdir}/%{qt_pkg}/bin/qdbusxml2cpp
%{_libdir}/%{qt_pkg}/bin/qmake
%{_libdir}/%{qt_pkg}/bin/qt3to4
%{_libdir}/%{qt_pkg}/bin/rcc
%{_libdir}/%{qt_pkg}/bin/uic
%{_libdir}/%{qt_pkg}/bin/uic3
%{_libdir}/%{qt_pkg}/doc
%{_libdir}/%{qt_pkg}/include
%{_libdir}/%{qt_pkg}/lib/libQt*.*a
%{_libdir}/%{qt_pkg}/lib/libQt*.prl
%{_libdir}/%{qt_pkg}/lib/libQt*.so
%{_libdir}/%{qt_pkg}/mkspecs
%{_libdir}/%{qt_pkg}/plugins/accessible/libqtaccessible*.a
%{_libdir}/%{qt_pkg}/plugins/codecs/libq*codecs.a
%{_libdir}/%{qt_pkg}/plugins/iconengines/libqsvg.a
%{_libdir}/%{qt_pkg}/plugins/imageformats/libq*.a
%{_libdir}/%{qt_pkg}/plugins/inputmethods/libqimsw-multi.a
%{_libdir}/%{qt_pkg}/plugins/sqldrivers/libq*.a
%{_libdir}/%{qt_pkg}/q3porting.xml
%{_libdir}/%{qt_pkg}/translations/assistant_*.qm
%{_libdir}/pkgconfig/Qt*.pc
%config(noreplace) %{_datadir}/applications/%{qt_pkg}-assistant.desktop
%{_datadir}/pixmaps/assistant%{qt_vstr}.png

%files designer
%defattr(-,root,root)
%{_bindir}/designer%{qt_vstr}
%{_bindir}/linguist%{qt_vstr}
%{_libdir}/%{qt_pkg}/bin/designer
%{_libdir}/%{qt_pkg}/bin/linguist
%{_libdir}/%{qt_pkg}/bin/lrelease
%{_libdir}/%{qt_pkg}/bin/lupdate
%{_libdir}/%{qt_pkg}/bin/pixeltool
%dir %{_libdir}/%{qt_pkg}/plugins/designer
%{_libdir}/%{qt_pkg}/plugins/designer/lib*.so
%{_libdir}/%{qt_pkg}/translations/designer_*.qm
%{_libdir}/%{qt_pkg}/translations/linguist_*.qm
%config(noreplace) %{_datadir}/applications/%{qt_pkg}-designer.desktop
%config(noreplace) %{_datadir}/applications/%{qt_pkg}-linguist.desktop
%{_datadir}/pixmaps/designer%{qt_vstr}.png
%{_datadir}/pixmaps/linguist%{qt_vstr}.png

%files mysql
%defattr(-,root,root)
%{_libdir}/%{qt_pkg}/plugins/sqldrivers/libqsqlmysql.so

%files odbc
%defattr(-,root,root)
%{_libdir}/%{qt_pkg}/plugins/sqldrivers/libqsqlodbc.so

%files pgsql
%defattr(-,root,root)
%{_libdir}/%{qt_pkg}/plugins/sqldrivers/libqsqlpsql.so

%files sqlite
%defattr(-,root,root)
%{_libdir}/%{qt_pkg}/plugins/sqldrivers/libqsqlite.so


%changelog
* Wed Oct 01 2008 Peter Pramberger <peterpramb@member.fsf.org> - 4.3.5-1
- New version (4.3.5)

* Fri Apr 11 2008 Peter Pramberger <peterpramb@member.fsf.org> - 4.3.4-1
- Initial build
